#!/usr/bin/perl5 -w

#netsaint_alarm

#########################################################################
# 9 July 1999 - 6pm Ver 1.1						#
# Written By Richard Mayhew - South Africa				#
# Email : netsaint@splash.co.za						#
# Copyright 1999 (c) Richard Mayhew					#
# Credits go to Ethan Galstad for coding NetSaint			#
# If any changes are made to this script, please mail me a copy of the	#
# changes :)								#	
# This Script will check the status log every 2 min and sound an	#
# alarm if any servers / services are down				#
#									#
# Recommendation - Sound configured on your server	 :)		#
#									#
#########################################################################

#Cron Job info
#The execution of MRTG must run every 5 min. 
#Eg Cron Entry
#*/2 * * * * /usr/local/netsaint/netsaint_alarm/netsaint_alarm.pl &> /dev/null

#---------------------------------------------VARIABLES

#Location of GREP program (ie /bin/grep)
$greplocation = "/bin/grep";

#Location of NetSaint status.log Data (ie /usr/local/netsaint)
$statuslog = "/usr/local/netsaint/var/status.log";

#Number Of Repeats for Sound
$repeats = "5";

$down = `$greplocation -c 'DOWN' $statuslog`;
$critical = `$greplocation -c 'CRITICAL' $statuslog`;
$unreachable = `$greplocation -c 'UNREACHABLE' $statuslog`;
$warning = `$greplocation -c 'WARNING' $statuslog`;
$unknown = `$greplocation -c 'UNKNOWN' $statuslog`;
$recovery = `$greplocation -c 'RECOVERY' $statuslog`;

#-----------------------------------------------CHECK ROUTINE

#check down servers / services

	if ( ($down > 0) || ($critical > 0) || ($unknown > 0) || ($warning > 0) 
			|| ($unreachable > 0)) {
		
				for($x=0;$x<$repeats;$x++) {
				`./netsaintring_down`; }
				}

#check for recovery of servers / services

	if ($recovery > 0) {

				for($x=0;$x<$repeats;$x++) {
				`./netsaintring_up`;}
				}


#The End :)
